﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace UltraGridWithSummaryFlightHours
{
    public partial class Form1 : Form
    {
        private ExternalSummaryValueEventArgs eArgs;
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            e.Row.Cells["Duration"].Value = (Convert.ToDateTime(e.Row.Cells["Arr"].Value) - Convert.ToDateTime(e.Row.Cells["Dep"].Value)).TotalMinutes;
            e.Row.Update();
        }

        private void ultraGrid1_SummaryValueChanged(object sender, Infragistics.Win.UltraWinGrid.SummaryValueChangedEventArgs e)
        {
            double number;
            if (e.SummaryValue.SummarySettings.SourceColumn.Key == "Duration" && Double.TryParse(e.SummaryValue.Value.ToString(), out number))
            {
                TimeSpan span = System.TimeSpan.FromMinutes(Convert.ToDouble(e.SummaryValue.Value));
                string hours = ((int)span.TotalHours).ToString();
                string minutes = span.Minutes.ToString();
                eArgs.SummaryValue.SetExternalSummaryValue(hours + " h " + minutes + " min");
            }
        }

        private void ultraGrid1_ExternalSummaryValueRequested(object sender, Infragistics.Win.UltraWinGrid.ExternalSummaryValueEventArgs e)
        {
            eArgs = e;
        }
    }
}
